#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *cigets (char *, int , FILE *);

#define TAM_FRASE   80

int main () 
{
  char buffer[TAM_FRASE + 1] = "\n";
  char **frases;
  int i, nfrs;

  frases = (char **) calloc (1, sizeof(char *));
  if (frases == NULL)
    fprintf (stderr, "ERRO DE ALOCACAO DE FRASES\n");
  else {
    for (nfrs = 0; strlen(buffer); nfrs++) {
      printf("Entre com frase %d: ", nfrs + 1);
      if(cigets(buffer, TAM_FRASE, stdin) != NULL)
	if((frases[nfrs] = strdup(buffer)) != NULL)
	  frases = (char **) realloc (frases, (nfrs + 2) * sizeof(char *));
    }
  }  /* FIM (frases == NULL) */
}

  
/* Mesmo que fgets(), mas retira do buffer o caracter '\n' final que
 * fgets() insere no buffer de entrada */

char *cigets (char *buffer, int size, FILE *stream)
{
  int i;
  buffer = fgets(buffer, size, stream);
  
  /* elimina '\n' inserido por fgets() */
  if (buffer != NULL) {
    for (i = strlen(buffer); buffer[i] != '\n'; i--);
    buffer[i] = '\0';
  }
  
  return buffer;
}
